SuperStrict

'Mit OpenGL erschien es mir schneller, daher den entspr. Treiber laden:
Framework BRL.GLMax2D
Import BRL.Timer
Import BRL.PNGLoader
SetGraphicsDriver GLMax2DDriver()

'Wegen der Animation unabdingbar, der Prozessor-schonende Timer:
Global timer:TTimer = CreateTimer(60)

'Ausnahmsweise ein Vollbildschirm des vorhandenen PC's:
Global scx% = DesktopWidth(), scy% = DesktopHeight()
Graphics scx, scy, DesktopDepth()

'die kompletten Regenbogenfarben als Spektrum mit entspr. RGB-Daten definieren:
Global Red%[1536], Green%[1536], Blue%[1536]
For Local i% = 0 To 255
	Red[i] = 255
	Green[i] = i
	Red[256+i] = 255 - i
	Green[256+i] = 255
	Green[512+i] = 255
	Blue[512+i] = i
	Green[768+i] = 255 - i
	Blue[768+i] = 255
	Blue[1024+i] = 255
	Red[1024+i] = i
	Blue[1280+i] = 255 - i
	Red[1280+i] = 255
Next

'Als erstes soll ein der individuellen Bildschirmgroesse optimal
'angepasster weisser Drache gezeichnet werden. Die Startposition,
'die maximale Ordnung und die Anfangsrichtung sind Erfahrungswerte:
If scy < 850 Then
	white_dragon(0.5*scx-214, 0.5*scy+84, 17, 0)
ElseIf scx < 1535 Or scy < 1023 Then
	white_dragon(0.5*scx-172, 0.5*scy+256, 18, 3)
Else
	white_dragon(0.5*scx-430, 0.5*scy+170, 19, 3)
End If
DrawText "Mit Mausklick weiter zur animierten Reise", 10, 30
DrawText "durch den Regenbogendrachen 20.Ordnung", 10, 50
Flip

'Warten auf die Benutzereingaben, bis es weitergeht ...
Repeat
	WaitTimer(timer)
	If MouseDown(1) Or MouseDown(2) Then Exit
	If KeyDown(KEY_ESCAPE) Then End
Forever

'Fr die folgende Berechnung knnte u.U. einige Zeit vergehen, darum ...
Cls
DrawText "Bitte warten:  Reisevorbereitungen ...",scx/2-152, scy/2-10
Flip

'Nun wird das Bild eines farbigens Drache 20.Ordnung erstellt,
'welcher mit den Maen 2047 x 1707 in der Regel fr jeden Bild-
'schirm zu gro ist, darum wird er aus einzelnen Teilen zusammengesetzt:
Local dragon:TImage = load_bigdragonimage()
MidHandleImage(dragon)

'Am Ende der folgenden Animation soll der (zu groe) farbige Drache geringst-
'mglich verkleinert werden, damit er komplett in den Bildschirm (mit
'ein bisschen Abstand) passt, darum hier die Berechnung der Skalierung:
Local start_scale# = 2 + Min(scx/2068.0, scy/1727.0)

'Zeit messen:
Local time% = MilliSecs()
'und Maus verstecken (die strt nur den Anblick):
HideMouse()
'und es folgt die Animationsschleife:
Repeat
	Cls

	'die "Reise" soll eine halbe Minute dauern, darum hier der Fortschritt:
	Local value# = (MilliSecs() - time) / 30000.0
	
	'der Drachen soll insgesamt eine halbe Drehung machen:
	SetRotation value*180
	
	'die Reise fhrt spiralfrmig durch den Drachen, um seine eigene Ent-
	'stehung mit Hilfe des Farbspektrums nachvollziehen zu knnen, darum
	'soll der Abstand vom Zentrum (quadratisch) immer kleiner werden:
	Local distance# = 750 - value*value*750
	'ausgehend vom Startwinkel 115 (da wo ungefhr der Anfang liegt)
	Local angle# = 115 + 420*value*value
	
	'die "Flughhe" soll kontinuierlich bis zum bereits errechneten
	'Endwert ansteigen, so dass am Anfang viel Detail und am Ende
	'die Totale des Regenbogendrachens zu sehen sein wird:	
	Local scale# = start_scale - 2*value
	SetScale scale, scale
	
	'Die Drehung und Betrachtung soll immer zentriert sein, darum:
	SetImageHandle dragon, 1024 + distance*Cos(angle), 853 + distance*Sin(angle)
	DrawImage dragon, 0.5*scx, 0.5*scy
	
	'zum Schluss ein paar Hinweise ...
	SetScale 1,1
	SetRotation 0
	DrawText "Regenbogen-Drachenkurve 20.Ordnung", 10, 10
	DrawText "Mit Escape abbrechen", 10, 30
	Flip
	WaitTimer(timer)
	If KeyDown(KEY_ESCAPE) Then End
	If value >= 1 Then Exit 'Reise zu Ende!
Forever
'Am Ende der animierten Reise ein automatisches Abspeichern der Drachenkurve:
SavePixmapPNG(LockImage(dragon), "BlitzMoritz-Regenbogendrachen 20.Ordnung.png")
'Warten auf das Ende ...
Repeat
	WaitTimer(timer)
	If KeyDown(KEY_ESCAPE) Then End
Forever

'Nun folgenden die eigentlichen Algorithmen fr die Drachenkurven
'----------------------------------------------------------------

'Die folgende Funktion malt eine Drachenkurve beliebiger Ordnung,
'die von ihrem Anfang bis zum Ende die Regenbogenfarben einmal durchluft.

'Die Argumente x und y geben die Startposition des Fraktals an,
'der Wert max_2exp die Ordnung der Kurve bzw. ihre immanente Zweierpotenz,
'die "start_direction bestimmt", in welche Richtung der erste Schritt geht.

Function rainbow_dragon(x%, y%, max_2exp%, start_direction%)

	Local sum%		'zhlt als Laufvariable alle gezeichneten Schritte
	Local totalsum# = 2*2^max_2exp	 'ist die erwartete Gesamtzahl aller Schritte
	
	Local direction%[] = [start_direction] 'ist ein Array, der sich alle Schritte einer Ordnung merkt.
	Local next_direction%[] 'ist jener Array, der die vorigen Schritte rckwrts durchluft und dreht.
	
	Local x_step%[] = [0,1,0,-1]	 'hier werden die vier Bewegungsrichtungen festgelegt:
	Local y_step%[] = [-1,0,1,0]	 '0 = nach Oben, 1 = nach Rechts, 2 = nach Unten, 3 = nach Links.
	
	Local count% = 1	'merkt sich die Gre des direction-Arrays
	
	'Nun leitet sich jede weitere Ordnung aus der vorigen ab (bis zur definierten Zielordnung.)
	For Local e% = 0 To max_2exp
		next_direction = New Int[count]
		
		'jeder Schritt der vorigen Ordnung kommt zum Tragen:
		For Local i% = 0 Until count
		
			'die Indexposition innerhalb des Regenbogenspektrums:
			Local RGB_Index% = sum / totalsum * 1536
			
			'damit Details sichtbar werden, hier eine periodische Abstufung der Helligkeit,
			'wobei der Wert 543210 nichts besonderes bedeutet, als dass es gut aussieht:
			Local brigthness# = 0.7 + 0.3 * Sin(sum / totalsum * 543210)
			SetColor brigthness*Red[RGB_Index], brigthness*Green[RGB_Index], brigthness*Blue[RGB_Index]
			sum:+1	 'Zhlung aller Punkte
			
			Plot x,y
			
			'die neuen Punkte der nchsten Ordnung laufen die alten umgekehrt durch,
			'und werden durch die Addition + 1 um 90 gedreht:		
			next_direction[i] = (direction[count-1-i] + 1) Mod 4
			
			'Update der Position:
			x = x + x_step[next_direction[i]]
			y = y + y_step[next_direction[i]]		
		Next
		
		'Nun wird aus den beiden Teilen der neue Array zusammengefgt:
		direction = direction + next_direction
		
		'und die Zweierpotenz weitergezhlt:
		count:*2
	Next
End Function


'der wei-schattierte Drachen enthlt nichts Neues, sondern re-
'duziert nur die Farbgebung und ergnzt die Messung der Rechenzeit:

Function white_dragon(x%, y%, max_2exp%, start_direction%)
	Local sum%, totalsum# = 2*2^max_2exp
	Local next_direction%[], direction%[] = [start_direction]
	Local x_step%[] = [0,1,0,-1]
	Local y_step%[] = [-1,0,1,0]
	Local count% = 1, time% = MilliSecs()
	For Local e% = 0 To max_2exp
		next_direction = New Int[count]
		For Local i% = 0 Until count
			Local brigthness# = 179 + 77.0 * Sin(sum / totalsum * 543210)
			sum:+1
			SetColor brigthness, brigthness, brigthness
			Plot x,y			
			next_direction[i] = (direction[count-1-i] + 1) Mod 4
			x = x + x_step[next_direction[i]]
			y = y + y_step[next_direction[i]]		
		Next
		direction = direction + next_direction
		count:*2
	Next
	SetColor 200,200,200
	DrawText "Weisse Drachenkurve " + max_2exp + ".Ordnung in " + (MilliSecs()-time) + " Millisekunden.", 10, 10
End Function


'In der abschlieenden Funktion wird ein Bild, das fr den Bildschirm
'eigentlich zu gro ist, aus mehreren Drachenzeichnungen zusammengefgt:

Function load_bigdragonimage:TImage()

	'In der Hoffnung, dass solch kleine Auflsung heute nicht mehr verwendet werden:
	If scx < 1024 Or scy < 569 Then RuntimeError("Die Bildschirmaufloesung ist zu niedrig!")
	
	'Die Gesamtpixmap mit der Gre 2048 x 1707 Pixel:
	Local TotalPixmap:TPixmap = CreatePixmap(2048, 1707, PF_BGRA8888)
	
	'und der jeweils gegrabbte Teil:
	Local Part:TPixmap
	
	
	'Abhngig von der Bildschirmauflsung werden jetzt 5 bzw. 4 oder 3 Drachen 20.Ordnung
	'mit variabler Position gezeichnet und gegrabbt, das dauert ein wenig ....
	
	If scy < 854 Then '(die Hlfte der vertikalen Tiefe 1707 Pixel)
		For Local i% = 0 To 1
			For Local j% = 0 To 2
				'Ganz Rechts unten befindet sich eine leere Zeichenlcke,
				If i+j = 3 Then Exit 'die darum nicht gegrabbt werden muss.
				Cls
				'Drachen malen ...
				rainbow_dragon(682 - i*1024, 1366 - j*569, 20, 2)
				'Teil grabben ...
				Part = GrabPixmap(0,0,1024,569)
				'In Gesamtbild einkleben ...
				TotalPixmap.Paste(Part, i*1024, j*569)
			Next
		Next
	Else
		For Local i% = 0 To 1
			For Local j% = 0 To 1
				'Eventuell befindet sich auch hier Rechts unten eine leere Zeichenlcke,
				If i+j = 2 And scy >= 1023 Then Exit 'die darum nicht gegrabbt werden muss.
				Cls
				'Drachen malen ...
				rainbow_dragon(682 - i*1024, 1366 - j*scy, 20, 2)
				'Teil grabben ...
				If j = 0 Then
					Part = GrabPixmap(0,0,1024,scy)
				Else	'die unteren Teile drfen zum pasten nicht zu gro sein:
					Part = GrabPixmap(0,0,1024,1707-scy)
				End If
				'In Gesamtbild einkleben ...
				TotalPixmap.Paste(Part, i*1024, j*scy)
			Next
		Next
	End If
	SetColor 255,255,255
	'Das Gesamtbild soll keinen schwarzen Hintergrund haben:
	TotalPixmap = MaskPixmap(TotalPixmap,0,0,0)
	'Rckgabe des erstellten Gesamtbilds als TImage:
	Return LoadImage(TotalPixmap)
End Function




